<?xml version="1.0"?>
<!-- File Name: Childitems.xsl -->

<!-- SQL-SELECT:
SELECT Relation.object_id, Subject.subj_nm ; &&, Data.date 
 FROM  forum!subject INNER JOIN forum!data;
    INNER JOIN forum!relation ;
   ON  Data.object_id = Relation.object_id ;
   ON  Subject.subj_id = Data.subj_id;
 WHERE (EMPTY(?m.gnKey) AND Relation.object_id = Relation.parent_id);
   OR (Relation.parent_id = ?m.gnKey AND Relation.object_id <> ?m.gnKey) ;
 ORDER BY Data.date
 --> 

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:XHTML="http://www.w3.org/TR/xhtml1">

	<xsl:output method="html" version="1.0" indent="yes" encoding="Windows-1251"/>
	
	<!-- Global parameters and external documents -->
	<xsl:param name="prmParentObject_id" select="'1'"/>
	<xsl:param name="prmDocData"/> <!-- select="document('Data/Data.xml')" -->
	<xsl:param name="prmDocSubj"/> <!-- select="document('Data/Subject.xml')" -->
	<xsl:variable name="varStylePaddingLeft" select="'padding-left: 15;'"/>
	
	<xsl:template match="/">
		<!-- First step: main transformation into variable varTemp -->
		<xsl:variable name="varTemp">
			<xsl:apply-templates select="/" mode="first"/>
		</xsl:variable>
		<!-- Second step: resorting -->
		<xsl:apply-templates select="msxsl:node-set($varTemp)/DIV" mode="second">
			<xsl:sort select="date_time"/>
		</xsl:apply-templates>
	</xsl:template>
	
	<!-- Main transformation -->
	<xsl:template match="relation" mode="first">
		<!-- For $prmParentObject_id & children items only -->
		<xsl:if test="($prmParentObject_id='0' and object_id = parent_id) or (parent_id = $prmParentObject_id and object_id != $prmParentObject_id)">
			
			<!-- Set environment for current element  -->
			<xsl:variable name="varObject_id" select="object_id"/>
			<xsl:variable name="varObject" select="$prmDocData/VFPData/data/object_id[.=$varObject_id]/parent::node()"/>
			<xsl:variable name="varSubj_id" select="$varObject/subj_id"/>
			<xsl:variable name="varDate" select="$varObject/date"/>
			<xsl:variable name="varSubj_nm" select="$prmDocSubj/VFPData/subject/subj_id[.=$varSubj_id]/parent::node()/subj_nm"/>
			
			<!-- Class item -->
			<xsl:element name="DIV">
				<!-- Attributes -->
				<xsl:attribute name="class">
					<xsl:text>item</xsl:text>
				</xsl:attribute>					
				<xsl:attribute name="id">
					<xsl:value-of select="$varObject_id"/>
				</xsl:attribute>					
				<xsl:attribute name="style">
					<xsl:value-of select="$varStylePaddingLeft"/>
				</xsl:attribute>					
				
				<!-- Class image -->
				<xsl:element name="IMG">
					<xsl:attribute name="class">
						<xsl:text>image</xsl:text>
					</xsl:attribute>					
					<xsl:attribute name="src">
						<xsl:text>images/collaps.jpg</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="border">
						<xsl:text>0</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="width">
						<xsl:text>14</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="height">
						<xsl:text>15</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>clickObj(this)</xsl:text>
					</xsl:attribute>
				</xsl:element>
				
				<!-- Class space -->
				<xsl:element name="SPAN">
					<xsl:attribute name="class">
						<xsl:text>space</xsl:text>
					</xsl:attribute>					
					<xsl:text> </xsl:text>
				</xsl:element>
				
				<!-- Class subj_nm -->
				<xsl:element name="SPAN">
					<xsl:attribute name="class">
						<xsl:text>subj_nm</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="title">
						<xsl:value-of select="$varSubj_nm"/>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>clickObj(this)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onmouseover">
						<xsl:text>mouseoverObj(this)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onmouseout">
						<xsl:text>mouseoutObj(this)</xsl:text>
					</xsl:attribute>
					<xsl:value-of select="$varSubj_nm"/>
				</xsl:element>

				<!-- date_time element for sorting only -->
				<xsl:element name="date_time">
					<xsl:value-of select="$varDate"/>
				</xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<!-- Transform date_time element into empty -->
	<xsl:template match="date_time" mode="second"/>

	<!-- Copy any object as output result -->
	<xsl:template match="@*|node()" mode="second">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()" mode="second"/>
		</xsl:copy>
	</xsl:template>
</xsl:stylesheet>


