<!--
////////////////////////////////////////////////////
// File: tree.js
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author:  Michael Drozdov
// Company: ICS Soft
// Country: Russia
// Sity:    Perm 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Mailto:Drozdov@ics.perm.su 
// My Page: http://vfpdmur.narod.ru/
// ICS Page: http://ics.perm.ru/ [on Russian]
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Revision History:
//   Ver.  Date          Comment
//   0.1   07/06/2002    Initial version started
//   0.2   07/25/2002    1) Now only Childitems.xsl used for Root & Child items:
//                          sId = "0" for root items, otherwise children items 
//                       2) The result received from Childitems.xsl is sorted by Data.date
//                       3) Any XML/XSL-file only once is loaded
////////////////////////////////////////////////////

////////////////////////////////////////////////////
// Global variables & constants
// (The part from them is used in contents.js also)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Source files:
var gsChildrenXML = "Data/Relation.xml";
var gsChildrenXSL = "Childitems.xsl";
var gsDataXML = "Data/Data.xml";
var gsDataXSL = "Data.xsl";
var gsSubjXML = "Data/Subject.xml";
var gsAuthorXML = "Data/Author.xml";
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Referencese to Microsoft.xmldom objects
var goXmlChildDoc = null;
var goXslChildDoc = null;
var goXslProc = null;		// used in contents.js also
var goXmlSubjDoc = null;	// used in contents.js also
var goXmlDataDoc = null;	// used in contents.js also
var goXslDataDoc = null;	// hold reference for use in contents.js only
var goXmlAuthorDoc = null; 	// hold reference for use in contents.js only
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// PROGIDs:
var gsMsxmlVersion = "3.0";
// Also you can use 4.0 versions:
//var gsMsxmlVersion = "4.0";
var gsPROGIDmsxml = "Msxml2.DOMDocument."+gsMsxmlVersion;
var gsPROGIDmsxsl = "Msxml2.FreeThreadedDOMDocument."+gsMsxmlVersion;
var gsPROGIDmstemp = "Msxml2.XSLTemplate."+gsMsxmlVersion;
var gbMsxml40 = (gsPROGIDmsxml.lastIndexOf("4.0") != (-1));
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Indexes classes in CSS-file
var gnRulesMouseOver = 0;
var gnRulesSubj_selected = 1;
var gnRulesSubj_nm = 2;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Other
var gnLengthItem = 3;		// min number of elements in tree-item (if no any child items)
var goSelectedObj = null;	// refernce to current selected object
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
////////////////////////////////////////////////////

////////////////////////////////////////////////////
// Create all Microsoft.xmldom objects
// and load all XML/XSL-files
function createXmlDoms()
{
	if (goXmlChildDoc == null)
	{
		goXmlChildDoc = new ActiveXObject(gsPROGIDmsxml);
		if (goXmlChildDoc == null)
		{
			return false;
		}
		goXmlChildDoc.async = false;
		if (!loadXML(goXmlChildDoc, gsChildrenXML))
		{
			goXmlChildDoc = null;
			return false;
		}
	}
	if (goXslChildDoc == null)
	{
		goXslChildDoc = new ActiveXObject(gsPROGIDmsxsl);
		if (goXslChildDoc == null)
		{
			return false;
		}
		goXslChildDoc.async = false;
		if (!loadXML(goXslChildDoc, gsChildrenXSL))
		{
			goXslChildDoc = null;
			return false;
		}
		// Reset parameters in xsl-document
		// according to the current XML version
		if (gbMsxml40)
		{ 
			goXslChildDoc.setProperty("SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'");
		}
	}
	if (goXslProc == null)
	{
		goXslProc = new ActiveXObject(gsPROGIDmstemp);
		if (goXslProc == null)
		{
			return false;
		}
	}
	if (goXmlDataDoc == null)
	{
		goXmlDataDoc = new ActiveXObject(gsPROGIDmsxml);
		if (goXmlDataDoc == null)
		{
			return false;
		}
		goXmlDataDoc.async = false;
		if (!loadXML(goXmlDataDoc, gsDataXML))
		{
			goXmlDataDoc = null;
			return false;
		}
	}
	if (goXmlSubjDoc == null)
	{
		goXmlSubjDoc = new ActiveXObject(gsPROGIDmsxml);
		if (goXmlSubjDoc == null)
		{
			return false;
		}
		goXmlSubjDoc.async = false;
		if (!loadXML(goXmlSubjDoc, gsSubjXML))
		{
			goXmlSubjDoc = null;
			return false;
		}
	}
	return true;
}

////////////////////////////////////////////////////
// Top-level handler of event click
function clickObj(obj)
{
	if (obj == null || typeof(obj) == "undefined")
	{
		alert("clickObj: error type arg");
	}
	else
	{
		// Get & Chech parentElement property
		var oParentObj = obj.parentElement
		if (oParentObj == null || typeof(oParentObj) == "undefined")
		{
			alert("clickObj: not found object.parentElement");
			return ;
		}
		// Get 'id' property from object.parentElement
		var sId = oParentObj.id;
		if (typeof(sId) != "string" || sId.length == 0)
		{
			alert("clickObj: not found 'id' property in object.parentElement");
			return ;
		}
		// Check className of Object
		switch(obj.className)
		{
		case "image":
			click_image(oParentObj, obj, sId);
			break;
		case "subj_selected":
		case "subj_nm":
			click_subj(obj, sId);
			break;
		default :
			alert("clickObj: unexpected Object: '"+obj.className+"'");
		}
	}
	return ;
}

//////////////////////////////////////////////////////////
// Handler of event click on element from class image 
function click_image(oParent, obj, sId)
{
	if ( obj == null || typeof(obj) == "undefined")
	{
		alert("click_image: error type arg");
		return ;
	}
	if (obj.className != "image")
	{
		alert("click_image: error className in arg");
		return ;
	}
	//-- How to do it: 
	// obj.style.cursor="wait";
	// or document.documentElement.style.cursor="wait";
	// sleep(0);
	//-- ???
	// Get filename position
	var sSrcFile = obj.src;
	var nLastBS = sSrcFile.lastIndexOf("/");
	if (nLastBS == (-1))
	{
		alert("click_image: not found '/' in 'src' propert.");
		return ;
	}
	// Get filename & check expanded state
	var bExpanded = false;
	var sNewFile = "";
	var bRetVal = false;
	var sOlsFile = sSrcFile.substr(++nLastBS);
	switch(sOlsFile)
	{
	case "collaps.jpg":
		sNewFile = "expand.jpg";
		bRetVal = expandNode(oParent, sId);
		break;
	case "expand.jpg":
		sNewFile = "collaps.jpg";
		bRetVal = collapsNode(oParent, sId);
		bExpanded = true;
		break;
	case "nochilds.jpg":
		// No any actions
		//-- How to do it:
		// obj.style.cursor="hand";
		// sleep(0);
		//-- ???
		return ;
	default :
		//-- How to do it:
		// obj.style.cursor="hand";
		// sleep(0);
		//-- ???
		alert("click_image: unexpected src: '"+sOlsFile+"'");
		return ;
	}
	if (bRetVal)
	{
		// Replace to opposite state
		obj.src = sSrcFile.substring(0, nLastBS)+sNewFile; 
	}
	else
	{
		// Replace to no childrens
		// Only now Expand/Collaps event is off
		// Other words: Now Expand/Collaps event is protected
		// from any attempts to load childs elements
		// case "nochilds.jpg" abov
		obj.src = sSrcFile.substring(0, nLastBS)+"nochilds.jpg";
		obj.style.cursor="default"; 
	}
	//-- How to do it:
	// obj.style.cursor="hand";
	// sleep(0);
	//-- ???
	return ;
}

///////////////////////////////////////////////////////
// Expande node for tree-item
// oParent - object of class item (expanding item)
// sId - current object_id (id of oParent)
function expandNode(oParent, sId)
{
	var bRetVal = false;
	if (oParent == null || typeof(oParent) == "undefined")
	{
		alert("expandNode: error type arg oParent");
		return bRetVal;
	}
	
	// Check exist Childrens
	if (oParent.children.length <= gnLengthItem)
	{
		// No any loading subelements:
		// need load subelements for current expanding item
		status = "Loading ..."
		if (createXmlDoms())
		{
			// Set XSL-document as stylesheet
			goXslProc.stylesheet = goXslChildDoc.documentElement;
			// Create Processor
			var objXSLTProc = goXslProc.createProcessor();
			if (objXSLTProc != null)
			{
				// Set XML-document
				objXSLTProc.input = goXmlChildDoc;
				// Reset prmParentObject_id to object_id from expanding item
				objXSLTProc.addParameter("prmParentObject_id", sId);
				// Set XML-documents as parameters values
				objXSLTProc.addParameter("prmDocData", goXmlDataDoc);
				objXSLTProc.addParameter("prmDocSubj", goXmlSubjDoc);
				// Do transformation
				if (objXSLTProc.transform())
				{
					// Check result
					var sRetVal = objXSLTProc.output;
					if (sRetVal.length > 0)
					{
						// Set result
						oParent.insertAdjacentHTML("BeforeEnd", sRetVal);
						bRetVal = true;
					}
				}
			}
			else
			{
				alert("expandNode: can not createProcessor()");
			}
		}
		status = defaultStatus;
	}
	else
	{
		// Rest style as display only
		for(var nItem = gnLengthItem; nItem < oParent.children.length; nItem++)
		{
			oParent.children.item(nItem).style.display = "";
		}
		bRetVal = true;
	}
	return bRetVal;
}

///////////////////////////////////////////////////////
// Collaps node for tree-item
// oParent - object of class item (expanding item)
// sId - current object_id (id of oParent)
function collapsNode(oParent, sId)
{
	var bCollapsExist = false;
	if (oParent == null || typeof(oParent) == "undefined")
	{
		alert("collapsNode: error type arg oParent");
		return bCollapsExist;
	}
	if (oParent.children.length > gnLengthItem)
	{
		// Hide all childs
		for(var nItem = gnLengthItem; nItem < oParent.children.length; nItem++)
		{
			oParent.children.item(nItem).style.display = "none";
		}
		bCollapsExist = true;
	}
	return bCollapsExist;
}

///////////////////////////////////////////////////////
// Handler of event click on element from class subj_nm 
function click_subj(obj, sId)
{
	if (obj == null || typeof(obj) == "undefined")
	{
		alert("click_subj: error type arg obj");
		return bRetVal;
	}
	if (goSelectedObj != null)
	{
		// Restore class for prev selected object
		goSelectedObj.className = "subj_nm";
    		// ... and syles
    		mouseoutObj(goSelectedObj)
	}
	// Set current object as selected
	obj.className = "subj_selected";
	goSelectedObj = obj
	// Set current sId as selected
	document.all("idObject").innerText = sId;
	// Refresh contents
	return refreshContents(sId);
}

///////////////////////////////////////////////////////
// Show contents for selected object
function refreshContents(sId)
{
	// Check this window as frame in frameset
	var oParent = window.parent;
	if (typeof(oParent) == "undefined")
	{
		alert("refreshContents: undefined 'window.parent' property");
		return ;
	}
	if (oParent.length != 2)
	{
		alert("refreshContents: no frames contained in the parent window");
		return ;
	}
	var oLocation = oParent.frames(1).location
	if (typeof(oLocation) == "undefined")
	{
		alert("refreshContents: undefined 'oParent.frames(1).location' property");
		return ;
	}
	// Get Location.href property & define filename position
	var sCurHref = oLocation.href;
	var nLastBS = sCurHref.lastIndexOf("/");
	if (nLastBS == (-1))
	{
		alert("refreshContents: not found '/' in 'href' property.");
		return ;
	}
	var sCurFile = sCurHref.substr(++nLastBS)
	switch(sId)
	{
		case "0":
		if (sCurFile != "About.htm")
		{
			// For top-level root-item - change to About.htm
			oLocation.href = sCurHref.substring(0, nLastBS)+"About.htm"; 
		}
		break;
		default :
		{
			// Otherwise - change to Contents.htm
			oLocation.href = sCurHref.substring(0, nLastBS)+"Contents.htm";
		}
	}
	return ;
}

// For classes: subj_nm & subj_selected
function mouseoverObj(obj)
{
	switch(obj.className)
	{
		case "subj_nm":
		case "subj_selected":
	    	with (document.styleSheets[0].rules[gnRulesMouseOver])
	    	{
			obj.style.color=style.color;
			obj.style.backgroundColor=style.background;
	    	}
	}
}
function mouseoutObj(obj)
{
	switch(obj.className)
	{
		case "subj_selected":
	    		with (document.styleSheets[0].rules[gnRulesSubj_selected])
			{
				obj.style.color=style.color;
				obj.style.backgroundColor=style.background;;
			}
			break;
		case "subj_nm":
	    		with (document.styleSheets[0].rules[gnRulesSubj_nm])
			{
				obj.style.color=style.color;
				obj.style.backgroundColor=style.background;;
			}
			break;
	}
}
//-->
