<!--
/////////////////////////////////////////////
// File: wrapxmldom.js
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Author:  Michael Drozdov
// Company: ICS Soft
// Country: Russia
// Sity:    Perm 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Mailto:Drozdov@ics.perm.su 
// My Page: http://vfpdmur.narod.ru/
// ICS Page: http://ics.perm.ru/ [on Russian]
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Date:   08/06/2002
// Revision History:
//    Date          Comment
//    08/06/2002    Initial version started
/////////////////////////////////////////////

///////////////////////////////////////////
// Parse error formatting function
function reportParseError(error)
{
    var s = "";
    for (var i=1; i<error.linepos; i++)
    {
        s += " ";
    }
    r = "<font size=4>XML Error loading '" + 
        error.url + "'</font><br>" +
        "<B>" + error.reason + 
        "</B></font>";
    if (error.line > 0)
        r += "<font size=3><XMP>" +
            "at line " + error.line + ", character " + error.linepos +
            "\n" + error.srcText +
            "\n" + s + "^" +
            "</XMP></font>";
return r;
}

/////////////////////////////////////////////////////////////////
// Load sSourceFile file [XML (or XSL)] for oXmlDom object
function loadXML(oXmlDom, sSourceFile)
{
    oXmlDom.load(sSourceFile);
    if (oXmlDom.parseError.errorCode != 0)
    {
        document.body.innerHTML = reportParseError(oXmlDom.parseError); 
        return false;
    }
    return true;
}

////////////////////////////////////////////////////////////////////////////
// Load sXmlFile file for oXmlDom object & sXslFile file for oXslDom object
// ... and transform first by used second 
function transformXML(oXmlDom, oXslDom, sXmlFile, sXslFile)
{
    // Check args
    if (oXmlDom == null 
        || oXslDom == null
        || sXmlFile.length == 0
        || sXslFile.length == 0)
        return "";
            
    // Load XML-file
    if (!loadXML(oXmlDom, sXmlFile))
        return "";

    // Load XSL-file
    if (!loadXML(oXslDom, sXslFile))
        return "";
        
    return oXmlDom.transformNode(oXslDom.documentElement);
}

//////////////////////////////////////////////////////////
// Replace value of attribute sVarName for oXmlDom object
// into the new value NewValue
function resetVariableAttribute(oXslDoc, sVarName, sNewValue)
{
	var bRetVal = false;
	if (oXslDoc == undefined || oXslDoc == null)
	{
		alert("resetVariableAttribute: error type arg 'oXslDoc'");
		return bRetVal;
	}
	if (typeof(sVarName) != "string")
	{
		alert("resetVariableAttribute: error type arg 'sVarName'");
		return bRetVal;
	}
	var oNode = oXslDoc.selectSingleNode("xsl:stylesheet/xsl:variable[@name='"+sVarName+"']");
	if (oNode != null)
	{
		oNode.setAttribute("select", "'"+sNewValue+"'");
		bRetVal = true;
	}
	else
	{
		alert("resetVariableAttribute: not found Attribute '"+sVarName+"'");
	}
	return bRetVal;
}
//-->